"""
    Signals API

    Collection of endpoints for providing Signal Events, Definitions and Metadata  # noqa: E501

    The version of the OpenAPI document: 2.6.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.Signals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.Signals.exceptions import ApiAttributeError



class EventHeadlineDataItem(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'request_id': (str,),  # noqa: E501
            'signal_id': (str,),  # noqa: E501
            'signal_name': (str,),  # noqa: E501
            'theme': (str,),  # noqa: E501
            'source': (str,),  # noqa: E501
            'event_id': (str,),  # noqa: E501
            'event_date': (date,),  # noqa: E501
            'summary': (str,),  # noqa: E501
            'user_relevance_score': (float,),  # noqa: E501
            'company_name': (str,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'request_id': 'requestId',  # noqa: E501
        'signal_id': 'signalId',  # noqa: E501
        'signal_name': 'signalName',  # noqa: E501
        'theme': 'theme',  # noqa: E501
        'source': 'source',  # noqa: E501
        'event_id': 'eventId',  # noqa: E501
        'event_date': 'eventDate',  # noqa: E501
        'summary': 'summary',  # noqa: E501
        'user_relevance_score': 'userRelevanceScore',  # noqa: E501
        'company_name': 'companyName',  # noqa: E501
        'created': 'created',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, request_id, signal_id, signal_name, theme, source, event_id, event_date, summary, user_relevance_score, *args, **kwargs):  # noqa: E501
        """EventHeadlineDataItem - a model defined in OpenAPI

        Args:
            request_id (str): The id that was requested. This can be a ticker, cusip or factset entity id.
            signal_id (str): Signal Id for this event. e.g. dilutionTrigger
            signal_name (str): Signal Name for this event. e.g. dilutionTrigger
            theme (str): Theme name of the signal for this event. e.g. Debt Capital Structure
            source (str): Primary data provider for the signal this event belongs to. e.g. FactSet, Bitvore
            event_id (str): A unique id for this event.
            event_date (date): The UTC date/time of the event in ISO 8601 format.
            summary (str): One sentence summary of the event.
            user_relevance_score (float): Relevancy score of this event for the requesting user on a scale of 0 to 1. Higher value indicates more relevancy.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            company_name (str): Name of the company reported in signal. Omitted if null.. [optional]  # noqa: E501
            created (datetime): Date/Time in UTC the event was first recorded in our data store.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.request_id = request_id
        self.signal_id = signal_id
        self.signal_name = signal_name
        self.theme = theme
        self.source = source
        self.event_id = event_id
        self.event_date = event_date
        self.summary = summary
        self.user_relevance_score = user_relevance_score
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, request_id, signal_id, signal_name, theme, source, event_id, event_date, summary, user_relevance_score, *args, **kwargs):  # noqa: E501
        """EventHeadlineDataItem - a model defined in OpenAPI

        Args:
            request_id (str): The id that was requested. This can be a ticker, cusip or factset entity id.
            signal_id (str): Signal Id for this event. e.g. dilutionTrigger
            signal_name (str): Signal Name for this event. e.g. dilutionTrigger
            theme (str): Theme name of the signal for this event. e.g. Debt Capital Structure
            source (str): Primary data provider for the signal this event belongs to. e.g. FactSet, Bitvore
            event_id (str): A unique id for this event.
            event_date (date): The UTC date/time of the event in ISO 8601 format.
            summary (str): One sentence summary of the event.
            user_relevance_score (float): Relevancy score of this event for the requesting user on a scale of 0 to 1. Higher value indicates more relevancy.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            company_name (str): Name of the company reported in signal. Omitted if null.. [optional]  # noqa: E501
            created (datetime): Date/Time in UTC the event was first recorded in our data store.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.request_id = request_id
        self.signal_id = signal_id
        self.signal_name = signal_name
        self.theme = theme
        self.source = source
        self.event_id = event_id
        self.event_date = event_date
        self.summary = summary
        self.user_relevance_score = user_relevance_score
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
